package audioplayerchopinzinhofm.lucas.com.audio_player_chopinzinhofm;
import android.app.Activity;
import android.content.Intent;
import android.support.v4.content.ContextCompat;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** AudioPlayerChopinzinhofmPlugin */
public class AudioPlayerChopinzinhofmPlugin implements MethodCallHandler {
  /**
   * Plugin registration.
   */
  private final Activity activity;
  private Intent serviceIntent;


  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "audio_player_chopinzinhofm");
    channel.setMethodCallHandler(new AudioPlayerChopinzinhofmPlugin(registrar.activity()));
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equalsIgnoreCase("startAudio")) {
      startService();
      result.success(true);
    } else if (call.method.equalsIgnoreCase("pauseAudio")) {
      pause();
      result.success(true);
    } else if (call.method.equalsIgnoreCase("stopAudio")) {
      stop();
      result.success(true);
    } else {
      result.notImplemented();
    }
  }

  private AudioPlayerChopinzinhofmPlugin(Activity activity) {
    this.activity = activity;
    this.serviceIntent = new Intent(activity, AudioService.class);
  }

  public void startService() {
    serviceIntent.setAction("action_play");
    ContextCompat.startForegroundService(activity, serviceIntent);
  }


  public void pause() {
    serviceIntent.setAction("action_pause");
    ContextCompat.startForegroundService(activity, serviceIntent);
  }

  public void stop() {
    serviceIntent.setAction("action_stop");
    ContextCompat.startForegroundService(activity, serviceIntent);
  }
}
